const express = require("express");
const app = express();
const http = require('http');
const bodyParser = require("body-parser");
const httpServer = http.Server(app);
const { isOSWindows, publicDir, homeDir, FileManager } = require('./fileManager');

module.exports = run

function run() {
	var port = 3201;
	httpServer.listen(port);

	app.use(bodyParser.json());
	app.use(bodyParser.urlencoded({ limit: '500mb', extended: true }));

	app.get("/get-add-in-info", async (req, res) => {
		res.status(200).send({ os: { isOSWindows, publicDir, homeDir }, extensionVersion: "1.2.3" });
	});

	app.post("/download-resources", async (req, res) => {
		try {
			const data = req.body;
			const fileManager = new FileManager(data);
			const deleteStatus = fileManager.checkDirsAndDeleteHomeFiles();

			let templates = [];
			let resources = [];

			if (deleteStatus.ok === true) {
				templates = await fileManager.processFiles(fileManager.publicDirInfo.startersLangDir, fileManager.homeDirInfo.startersDir, data.templates);
				resources = await fileManager.processFiles(fileManager.publicDirInfo.resourcesDir, fileManager.homeDirInfo.resourcesDir, data.resources);
			}
			else {
				res.status(200).send(deleteStatus);
				return;
			}

			res.status(200).send({ ok: true, publicDirInfo: fileManager.publicDirInfo, homeDirInfo: fileManager.homeDirInfo, templates, resources });
		} catch (error) {
			res.status(200).send({ ok: false, errorMessage: error.message });
		}
	});
}
